> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developers.awork.com/apiv1/workspace-absences/put-workspace-absence-by-id/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server. # Updates a workspace absence. PUT https://api.awork.com/api/v1/workspaceabsences/{workspaceAbsenceId} Content-Type: application/json Updates a workspace absence. The submitted dates and region determine when it applies.The user must be an admin or have `user-planning-data:write` permissions. Reference: https://developers.awork.com/apiv1/workspace-absences/put-workspace-absence-by-id ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `workspaceAbsenceId` (string, required) — The workspace absence to update. ### Body (application/json) This endpoint expects a WorkspaceAbsenceForm. - `startOn` (string, required) — The start time of the workspace absence. - `endOn` (string, required) — The end time of the workspace absence. - `description` (string, required) — The description of the workspace absence. - `regionId` (string, optional, nullable) — (optional) The id of the absence region to limit the workspace absence to. If not set, the workspace absence will apply to all users in the workspace. Otherwise, it will only apply to users in the specified absence region. - `isHalfDayOnStart` (boolean, optional) — If it's true, and it's a single day absence means that the absence is for the first half of the workday. If it's a multi day absence, it will start on the second half of the first day of the absence period. - `isHalfDayOnEnd` (boolean, optional) — If it's true, and it's a single day absence means that the absence is for the second half of the workday. If it's a multi day absence it will end on the first half of the last day of the absence period. ## Response ### 200 OK - `id` (string, optional) — The id of the entity. - `createdOn` (string, optional) — The date this entity was created. - `createdBy` (string, optional) — The id of the user who created this entity. - `updatedOn` (string, optional) — The date this entity was last modified. - `updatedBy` (string, optional) — The id of the user who last modified this entity. - `startOn` (string, optional) — The start time of the workspace absence. - `endOn` (string, optional) — The end time of the workspace absence. - `description` (string, optional, nullable) — The description of the absence. - `regionId` (string, optional, nullable) — The (optional) regionId of the workspace absence. If null, the absence is global for the entire workspace. Otherwise, it will be applied only to the users of the region. - `region` (string, optional, nullable) — The name of the region of the workspace absence. Null if the absence is global for the entire workspace. - `isReadOnly` (boolean, optional) — If it's true it means that this Absence is read-only and cannot be edited/deleted by the user. - `isHalfDayOnStart` (boolean, optional) — If it's true and it's a single day absence means that the absence is for the first half of the workday. If it's a multi day absence it started on the second half of the first day of the absence period. - `isHalfDayOnEnd` (boolean, optional) — If it's true and it's a single day absence means that the absence is for the second half of the workday. If it's a multi day absence it ended on the first half of the last day of the absence period. ## Errors ### 400 Bad Request Error Bad Request - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ### 404 Not Found Error Not Found - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ## Types ### ValidationErrorResponse The validation error response. - `property` (string, optional, nullable) — The name of the property that failed validation. - `message` (string, optional, nullable) — The reason why this property failed validation. ## Examples **Request** ```json { "startOn": "2022-03-01T00:00:00Z", "endOn": "2022-03-03T00:00:00Z", "description": "Company offsite" } ``` **Response** ```json { "id": "123e4567-e89b-12d3-a456-426614174000", "createdOn": "2022-03-11T15:33:47.100Z", "createdBy": "123e4567-e89b-12d3-a456-426614174000", "updatedOn": "2022-03-11T21:15:00.100Z", "updatedBy": "123e4567-e89b-12d3-a456-426614174000", "startOn": "2022-03-01T00:00:00Z", "endOn": "2022-03-03T00:00:00Z", "description": "Company offsite", "regionId": "123e4567-e89b-12d3-a456-426614174000", "region": "Hamburg", "isReadOnly": true, "isHalfDayOnStart": false, "isHalfDayOnEnd": false } ``` **SDK Code** ```python import requests url = "https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId" payload = { "startOn": "2022-03-01T00:00:00Z", "endOn": "2022-03-03T00:00:00Z", "description": "Company offsite" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId'; const options = { method: 'PUT', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"startOn":"2022-03-01T00:00:00Z","endOn":"2022-03-03T00:00:00Z","description":"Company offsite"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId" payload := strings.NewReader("{\n \"startOn\": \"2022-03-01T00:00:00Z\",\n \"endOn\": \"2022-03-03T00:00:00Z\",\n \"description\": \"Company offsite\"\n}") req, _ := http.NewRequest("PUT", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"startOn\": \"2022-03-01T00:00:00Z\",\n \"endOn\": \"2022-03-03T00:00:00Z\",\n \"description\": \"Company offsite\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"startOn\": \"2022-03-01T00:00:00Z\",\n \"endOn\": \"2022-03-03T00:00:00Z\",\n \"description\": \"Company offsite\"\n}") .asString(); ``` ```php request('PUT', 'https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId', [ 'body' => '{ "startOn": "2022-03-01T00:00:00Z", "endOn": "2022-03-03T00:00:00Z", "description": "Company offsite" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId"); var request = new RestRequest(Method.PUT); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"startOn\": \"2022-03-01T00:00:00Z\",\n \"endOn\": \"2022-03-03T00:00:00Z\",\n \"description\": \"Company offsite\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "startOn": "2022-03-01T00:00:00Z", "endOn": "2022-03-03T00:00:00Z", "description": "Company offsite" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/workspaceabsences/workspaceAbsenceId")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```